﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Net;
using System.IO;

namespace FlyBrowser
{
    public partial class myForm2 : Form
    {
        public myForm2()
        {
            InitializeComponent();

                        //清空控件   
            //this.MainTabControl.TabPages.Clear();   
            //绘制的方式OwnerDrawFixed表示由窗体绘制大小也一样   
            this.MainTabControl.DrawMode = TabDrawMode.OwnerDrawFixed;   
            this.MainTabControl.Padding = new System.Drawing.Point(CLOSE_SIZE, CLOSE_SIZE);   
            this.MainTabControl.DrawItem += new DrawItemEventHandler(this.MainTabControl_DrawItem);   
            this.MainTabControl.MouseDown += new System.Windows.Forms.MouseEventHandler(this.MainTabControl_MouseDown);

            //绑定
            myWeb.Tag = tabPageHome;
            tabPageHome.Tag = myWeb;

        }
        const int CLOSE_SIZE = 15;
        //tabPage标签图片   
        Bitmap image = null;// new Bitmap("E:\\ico_close.gif");

        //绘制“Ｘ”号即关闭按钮   
        private void MainTabControl_DrawItem(object sender, DrawItemEventArgs e)
        {
            try
            {
                TabPage tp = this.MainTabControl.TabPages[e.Index];
                Rectangle myTabRect = this.MainTabControl.GetTabRect(e.Index);
                

                Point p4 = new Point(myTabRect.X, 4);
                Bitmap btFavicon = new Bitmap(ilTab.Images[tp.ImageKey]);
                e.Graphics.DrawImage(btFavicon, p4);

                //先添加TabPage属性      
                e.Graphics.DrawString(this.MainTabControl.TabPages[e.Index].Text,
this.Font, SystemBrushes.ControlText, myTabRect.X+ CLOSE_SIZE + 2, myTabRect.Y + 2);
                //再画一个矩形框   
                using (Pen p = new Pen(Color.White))
                {
                    myTabRect.Offset(myTabRect.Width - (CLOSE_SIZE + 3), 2);
                    myTabRect.Width = CLOSE_SIZE;
                    myTabRect.Height = CLOSE_SIZE;
                    e.Graphics.DrawRectangle(p, myTabRect);
                }

                //填充矩形框   
                Color recColor = e.State == DrawItemState.Selected
                          ? Color.White : Color.White;
                using (Brush b = new SolidBrush(recColor))
                {
                    e.Graphics.FillRectangle(b, myTabRect);
                }

                //画关闭符号   
                using (Pen objpen = new Pen(Color.Black))
                {
                    ////=============================================   
                    //自己画X   
                    ////"\"线   
                    //Point p1 = new Point(myTabRect.X + 3, myTabRect.Y + 3);   
                    //Point p2 = new Point(myTabRect.X + myTabRect.Width - 3, myTabRect.Y + myTabRect.Height - 3);   
                    //e.Graphics.DrawLine(objpen, p1, p2);   
                    ////"/"线   
                    //Point p3 = new Point(myTabRect.X + 3, myTabRect.Y + myTabRect.Height - 3);   
                    //Point p4 = new Point(myTabRect.X + myTabRect.Width - 3, myTabRect.Y + 3);   
                    //e.Graphics.DrawLine(objpen, p3, p4);   

                    ////=============================================   
                    //使用图片   
                    Bitmap bt = new Bitmap(ilTab.Images[1]);
 
                    Point p5 = new Point(myTabRect.X, 4);
                    e.Graphics.DrawImage(bt, p5);
                    //e.Graphics.DrawString(this.MainTabControl.TabPages[e.Index].Text, this.Font, objpen.Brush, p5);   
                }
                e.Graphics.Dispose();
            }
            catch (Exception)
            { }
        }

        //关闭按钮功能   
        private void MainTabControl_MouseDown(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
            {
                int x = e.X, y = e.Y;
                //计算关闭区域      
                Rectangle myTabRect = this.MainTabControl.GetTabRect(this.MainTabControl.SelectedIndex);

                myTabRect.Offset(myTabRect.Width - (CLOSE_SIZE + 3), 2);
                myTabRect.Width = CLOSE_SIZE;
                myTabRect.Height = CLOSE_SIZE;

                //如果鼠标在区域内就关闭选项卡      
                bool isClose = x > myTabRect.X && x < myTabRect.Right && y >
                           myTabRect.Y && y < myTabRect.Bottom;
                if (isClose == true)
                {
                    TabPage tp = MainTabControl.SelectedTab;
                    if(tp==tabPageHome)
                    {
                        return;
                    }
                    WebBrowser wb = (WebBrowser)tp.Tag;

                    if (wb!=null)
                    {
                        wb.Dispose();
                        wb = null;

                    }
                    this.MainTabControl.TabPages.Remove(tp);
                    tp.Dispose();
                    tp = null;
                }
            }
        }

        private void theWeb_DocumentCompleted(object sender, WebBrowserDocumentCompletedEventArgs e)
        {
            Image img = null;
            WebBrowser web = (WebBrowser)sender;
            string imageKey = web.Document.Url.ToString();
            TabPage tb = (TabPage)web.Tag;
            tb.Text = web.Document.Title;
            tb.Size=new Size(tb.Size.Width + 8, tb.Size.Height);
            if ((string)tb.ImageKey != imageKey)
            {
                string url = GetFaviconUrl(web);
                if (url != null)
                {
                    img = GetFaviconImage(url);
                    if (img != null)
                    {
                        ilTab.Images.RemoveByKey(imageKey);
                        ilTab.Images.Add(imageKey, img);
                        tb.ImageKey = imageKey;
                    }
                }
                //tb.Tag = web.Document.Url.ToString();
            }


        }
        public string GetFaviconUrl(WebBrowser web)
        {
            string FaviconUrl = null;
            string tmpFaviconUrl = null;
            Uri uri = null;
            if (web.Document.Url.AbsolutePath.Equals("blank")) return null;
            try
            {
                foreach (HtmlElement eOne in web.Document.GetElementsByTagName("link"))
                {
                    if (eOne.GetAttribute("rel").ToLower().Equals("shortcut icon"))
                    {
                        tmpFaviconUrl = eOne.GetAttribute("href");
                        if(tmpFaviconUrl.ToLower().StartsWith("http://"))
                        {
                            FaviconUrl = tmpFaviconUrl;
                        }
                        else if(tmpFaviconUrl.StartsWith("//"))
                        {
                            FaviconUrl= "http:" + tmpFaviconUrl;
                        }
                        else if(!FaviconUrl.ToLower().StartsWith("http:"))
                        {
                            FaviconUrl = "http://" + FaviconUrl;
                        }
                        return FaviconUrl;
                    }
                }

            }
            catch { }
            //return null;  
            if (web.Document.Url.ToString().Length > 8 + web.Document.Url.Host.Length)
            {
                return web.Document.Url.ToString().Remove(8 + web.Document.Url.Host.Length) + "/favicon.ico";
            }
            else
            {
                return web.Document.Url.ToString() + "favicon.ico";
            }
        }
        public Image GetFaviconImage(string Url)
        {
            Image icon = null;
            WebClient wc=null;
            MemoryStream ms = null;
            if (Url != null)
            {
                try
                {
                    wc = new WebClient();
                    byte[] ic = wc.DownloadData(Url);
                    ms = new MemoryStream(ic);
                    icon = Image.FromStream(ms);
                }
                catch (Exception e)
                {
                    System.Console.Write("err");
                }
            }
            return icon;
        }

        private void theWeb_NewWindow(object sender, CancelEventArgs e)
        {
            WebBrowser wb = (WebBrowser)sender;
            WebBrowser wbNew = new WebBrowser();
            TabPage tpNew = new TabPage();

            MainTabControl.TabPages.Add(tpNew);
  
            panelWeb.Controls.Add(wbNew);
            wbNew.ScriptErrorsSuppressed = true;
            wbNew.Dock = DockStyle.Fill;
            wbNew.BringToFront();
            wbNew.Url = new Uri(wb.Document.ActiveElement.GetAttribute("href"));
            wbNew.DocumentCompleted += new System.Windows.Forms.WebBrowserDocumentCompletedEventHandler(this.theWeb_DocumentCompleted);
            wbNew.NewWindow += new System.ComponentModel.CancelEventHandler(this.theWeb_NewWindow);


            wbNew.Tag = tpNew;
            tpNew.Tag = wbNew;
            MainTabControl.SelectedTab = tpNew;

            e.Cancel = true;

        }

        private void MainTabControl_SelectedIndexChanged(object sender, EventArgs e)
        {
            TabControl tc = (TabControl)sender;
            TabPage tp = tc.SelectedTab;
            if (tp != null)
            {
                WebBrowser wb = (WebBrowser)tp.Tag;
                if (wb != null)
                {
                    wb.BringToFront();
                }
            }

        }

        private void myForm2_FormClosing(object sender, FormClosingEventArgs e)
        {
            TabControl tc = MainTabControl;
            foreach (TabPage tp in tc.TabPages)
            { 
                WebBrowser wb = (WebBrowser)tp.Tag;
                wb.Dispose();
                wb = null;
                tc.TabPages.Remove(tp);
                tp.Dispose();

            }

        }
    }
}
